/*
    Aufgabe4) Schleifen und Methoden
    Erweitern Sie die Klasse "Aufgabe4" um die statische Methode "calcCrossSum", die die Quersumme einer übergebenen
    Zahl berechnet.
    - Der Methode wird ein positiver ganzzahliger Wert übergeben.
    - Die Methode liefert das Ergebnis der Quersumme als ganzzahligen Wert zurück.

    Zusatzfragen:
    1) Welcher positiver ganzzahliger Wert muss der Methode übergeben werden damit die höchstmögliche Quersumme berechnet wird?
        höchster Wert von int, erste Stelle  -1, rest lauter 9er:
            (Integer.MAX_VALUE) 2147483647 -> 1999999999

        höchst möglicher Wert für die Quersumme wäre das Maximum von int (Integer.MAX_VALUE = 2147483647), da dieser
        nicht durch eine übergebene Zahl an calcCrossSum erreicht werden kann (maximum von int ist ja 2147483647), ist
        der höchste wert zu verwenden ...
*/
public class Aufgabe4 {

    public static int calcCrossSum(int wert) {
        //Überlegung: Zahl in String umwandeln und jede zahl einzeln addieren

        //wert wird in String umgewandelt, um charAt zu benutzen
        String wertStr = Integer.toString(wert);
        int quersumme = 0;

        //for-Schleife geht bis zur länge von wertStr jede Stelle durch und addiert diese (nummerischen Wert) zur
        // Quersumme
        for (int i = 0; i <  wertStr.length(); i++) {
            quersumme += Character.getNumericValue(wertStr.charAt(i));
        }

        //gibt die Quersumme aus
        return quersumme;
    }

    /* wesentlich eleganter lässt sich das wie folgt lösen:

    public static int calcCrossSum(int wert) {
        int quersumme = 0;
        while (wert > 0) {
            //zur quersumme wird der rest von der division durch 10 addiert
            quersumme += wert%10;
            //der wert wird um die division durch 10 verringert
            wert /= 10;
        }
        return quersumme;
    }

     */

    public static void main(String[] args) {
        //test
        System.out.println(calcCrossSum(777));
        System.out.println(calcCrossSum(1999999999));
    }
}
